import { useEffect, useRef } from 'react';
import { useDispatch } from 'react-redux';

import { loadReport } from '../state/actions';

export const useLoadReport = (reportId: string, id: number) => {
  const dispatch = useDispatch();
  const isMounted = useRef(true);

  useEffect(() => {
    if (reportId && !id) {
      if (isMounted.current) {
        dispatch(loadReport(Number(reportId)));
      }
    }
    return () => {
      isMounted.current = false;
    };
  }, [reportId, id, dispatch]);
};
